VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Registry"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Const MyName As String = "RegistryClass"

'...   98 ,      .
'  -  :)

' ...  ,   ,    98.
',  Regedit    String, Binary  DWORD.
'   Norton Registry Editor   MultiString  StringEx.
'  Regedit    Binary  String .
',        ?

Private Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" ( _
                  ByVal hKey As Long, _
                  ByVal lpSubKey As String, _
                  ByVal Reserved As Long, _
                  ByVal lpClass As String, _
                  ByVal dwOptions As Long, _
                  ByVal samDesired As Long, _
                  lpSecurityAttributes As Any, _
                  phkResult As Long, _
                  lpdwDisposition As Long) As Long

Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" ( _
                  ByVal hKey As Long, _
                  ByVal lpSubKey As String) As Long

Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long
Private Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, lpcbName As Long, lpReserved As Long, ByVal lpClass As String, lpcbClass As Long, lpftLastWriteTime As Any) As Long
Private Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long

'Note that if you declare the lpData parameter as String, you must pass it By Value.
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long

Private Declare Function RegRestoreKey Lib "advapi32.dll" Alias "RegRestoreKeyA" (ByVal hKey As Long, ByVal lpFile As String, ByVal dwFlags As Long) As Long
Private Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, ByVal cbData As Long) As Long
Private Declare Function RegSaveKey Lib "advapi32.dll" Alias "RegSaveKeyA" (ByVal hKey As Long, ByVal lpFile As String, lpSecurityAttributes As Any) As Long
Private Declare Function RegNotifyChangeKeyValue Lib "advapi32.dll" (ByVal hKey As Long, ByVal bWatchSubtree As Long, ByVal dwNotifyFilter As RegNotify, ByVal hEvent As Long, ByVal fAsynchronus As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function FormatMessage Lib "kernel32" Alias "FormatMessageA" (ByVal dwFlags As Long, lpSource As Any, ByVal dwMessageId As Long, ByVal dwLanguageId As Long, ByVal lpBuffer As String, ByVal nSize As Long, Arguments As Long) As Long

Private Declare Function GetEnvironmentStrings Lib "kernel32" Alias "GetEnvironmentStringsA" () As Long
Private Declare Function FreeEnvironmentStrings Lib "kernel32" Alias "FreeEnvironmentStringsA" (ByVal lpsz As String) As Long
Private Declare Function lstrlen Lib "kernel32" Alias "lstrlenA" (ByVal lpString As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (lpvDest As Any, lpvSource As Any, ByVal cbCopy As Long)

'Private Declare Function CreateEvent Lib "kernel32" Alias "CreateEventA" (lpEventAttributes As Any, ByVal bManualReset As Long, ByVal bInitialState As Long, ByVal lpName As String) As Long


'Private Type SECURITY_ATTRIBUTES
'  nLength As Long
'  lpSecurityDescriptor As Long
'  bInheritHandle As Long
'End Type
'
'Private Type FILETIME
'  dwLowDateTime As Long
'  dwHighDateTime As Long
'End Type

Enum RegRoots
  HKEY_CLASSES_ROOT = &H80000000
  HKEY_CURRENT_USER = &H80000001
  HKEY_LOCAL_MACHINE = &H80000002
  HKEY_USERS = &H80000003
  HKEY_PERFORMANCE_DATA = &H80000004
  HKEY_CURRENT_CONFIG = &H80000005
  HKEY_DYN_DATA = &H80000006
End Enum

Enum RegDataTypes
  REG_NONE = 0&                      ' No value type
  REG_SZ = 1&                        ' Unicode nul terminated string
  REG_EXPAND_SZ = 2&                 ' Unicode nul terminated string with templates
  REG_BINARY = 3&                    ' Free form binary
  REG_DWORD = 4&                     ' 32-bit number
  REG_DWORD_LITTLE_ENDIAN = 4&       ' 32-bit number (same as REG_DWORD)
  REG_DWORD_BIG_ENDIAN = 5&          ' 32-bit number (hi and low swapped)
  REG_LINK = 6&                      ' Symbolic Link (unicode)
  REG_MULTI_SZ = 7&                  ' Multiple Unicode strings
  REG_RESOURCE_LIST = 8&             ' Resource list in the resource map
  REG_FULL_RESOURCE_DESCRIPTOR = 9&  ' Resource list in the hardware description
  REG_RESOURCE_REQUIREMENTS_LIST = 10&
End Enum

Enum WhatCreateExDid
  REG_CREATED_NEW_KEY = &H1&          ' New Registry Key created
  REG_OPENED_EXISTING_KEY = &H2&      ' Existing Key opened
End Enum

Enum Reg1
  REG_WHOLE_HIVE_VOLATILE = &H1&      ' Restore whole hive volatile
  REG_REFRESH_HIVE = &H2&             ' Unwind changes to last flush
End Enum

Enum RegNotify
  REG_NOTIFY_CHANGE_NAME = &H1&       ' Create or delete (child)
  REG_NOTIFY_CHANGE_ATTRIBUTES = &H2&
  REG_NOTIFY_CHANGE_LAST_SET = &H4&   ' Time stamp
  REG_NOTIFY_CHANGE_SECURITY = &H8&
End Enum

Private Const ReadControl As Long = &H20000
Enum RegRights
  STANDARD_RIGHTS_READ = ReadControl
  STANDARD_RIGHTS_WRITE = ReadControl
  STANDARD_RIGHTS_EXECUTE = ReadControl
  STANDARD_RIGHTS_REQUIRED = &HF0000
  STANDARD_RIGHTS_ALL = &H1F0000
End Enum

Enum RegCreationTypes
  REG_OPTION_RESERVED = 0&           ' Parameter is reserved
  REG_OPTION_NON_VOLATILE = 0&       ' Key is preserved when system is rebooted
  REG_OPTION_VOLATILE = 1&           ' Key is not preserved when system is rebooted
  REG_OPTION_CREATE_LINK = 2&        ' Created key is a symbolic link
  REG_OPTION_BACKUP_RESTORE = 4&     ' open for backup or restore
  REG_LEGAL_CHANGE_FILTER = (REG_NOTIFY_CHANGE_NAME Or REG_NOTIFY_CHANGE_ATTRIBUTES Or REG_NOTIFY_CHANGE_LAST_SET Or REG_NOTIFY_CHANGE_SECURITY)
  REG_LEGAL_OPTION = (REG_OPTION_RESERVED Or REG_OPTION_NON_VOLATILE Or REG_OPTION_VOLATILE Or REG_OPTION_CREATE_LINK Or REG_OPTION_BACKUP_RESTORE)
End Enum

Private Const SYNCHRONIZE = &H100000
Enum RegSecurityFlags
  KEY_QUERY_VALUE = &H1&
  KEY_SET_VALUE = &H2&
  KEY_CREATE_SUB_KEY = &H4&
  KEY_ENUMERATE_SUB_KEYS = &H8&
  KEY_NOTIFY = &H10&
  KEY_CREATE_LINK = &H20&
  KEY_READ = ((STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not SYNCHRONIZE))
  KEY_WRITE = ((STANDARD_RIGHTS_WRITE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY) And (Not SYNCHRONIZE))
  KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL Or KEY_QUERY_VALUE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_CREATE_LINK) And (Not SYNCHRONIZE))
  KEY_EXECUTE = ((KEY_READ) And (Not SYNCHRONIZE))
End Enum

Private Const SUCCESS As Long = 0
Private Const ERROR_NO_MORE_ITEMS As Long = 259
Private Const FORMAT_MESSAGE_FROM_SYSTEM As Long = &H1000
Private Const REG_FORCE_RESTORE As Long = 8

Private Enum RegFileLineTypes
  '     LineType
  lineInvalid = REG_NONE
  lineString = REG_SZ
  lineDWord = REG_DWORD
  lineHex = REG_BINARY
  lineMultiString = REG_MULTI_SZ
  lineExpandedString = REG_EXPAND_SZ
  lineKey = -2
  lineDefault = -1
End Enum

Private Sub HandleError(ByVal ErrCode As Long, ByVal hKey As Long)
  Dim tmp As String
  If ErrCode = SUCCESS Then Exit Sub  '  
  If ErrCode = 2 Then Exit Sub        '     
  If ErrCode = ERROR_NO_MORE_ITEMS Then Exit Sub '   
  If hKey Then RegCloseKey hKey
  tmp = Space$(255)
  tmp = Left$(tmp, FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, ByVal 0&, ErrCode, 0&, tmp, 255, ByVal 0&))
  Err.Raise ErrCode, MyName, tmp
End Sub

Private Function ExpandString(str As String) As String
  Dim lngRet As Long, strDest As String, lLen As Long
  
  ExpandString = str
  lngRet = GetEnvironmentStrings 'inital pointer
  Do
    lLen = lstrlen(lngRet)
    If lLen = 0 Then Exit Do
    strDest = Space$(lLen)
    CopyMemory ByVal strDest, ByVal lngRet, lLen
    strDest = Left$(strDest, InStr(strDest, "=") - 1)
    If Len(strDest) > 0 Then
      If Len(Environ(strDest)) > 0 Then ExpandString = Replace$(ExpandString, "%" + strDest + "%", Environ(strDest), , , vbTextCompare)
    End If
    lngRet = lngRet + lstrlen(lngRet) + 1
  Loop
  FreeEnvironmentStrings lngRet
End Function

Property Get Value(ByVal Root As RegRoots, RegPath As String, ValueName As String, ByVal SaveAs As RegDataTypes) As Variant
Attribute Value.VB_UserMemId = 0
  ' SaveAs   Property Get  , .. 
  '   .       
  'Property Let,   VB     :(
  
  Dim keyHandle As Long, ret As Long
  Dim ValueType As RegDataTypes
  Dim strBuf As String, dwdBuf As Long, ReqBufSize As Long
  
  ret = RegOpenKeyEx(Root, RegPath, 0, KEY_ALL_ACCESS, keyHandle)
  HandleError ret, keyHandle
  
  If keyHandle = 0 Then   '   !
    Value = Empty
  Else                    '!
    ret = RegQueryValueEx(keyHandle, ValueName, 0&, ValueType, ByVal 0&, ReqBufSize) '    
    HandleError ret, keyHandle
    
    Select Case ValueType
    Case REG_BINARY, REG_SZ, REG_MULTI_SZ, REG_EXPAND_SZ
      strBuf = Space$(ReqBufSize)
      ret = RegQueryValueEx(keyHandle, ValueName, 0&, ValueType, ByVal strBuf, ReqBufSize)
      HandleError ret, keyHandle
      Value = Left$(strBuf, ReqBufSize - 1)
      ',   .    !
      '   Norton Registry Editor  :)
      If ValueType = REG_EXPAND_SZ Then Value = ExpandString(CStr(Value))
    Case REG_DWORD
      ret = RegQueryValueEx(keyHandle, ValueName, 0&, REG_DWORD, dwdBuf, ReqBufSize)
      HandleError ret, keyHandle
      Value = IIf(dwdBuf < 0, dwdBuf + 4294967296#, dwdBuf)
    Case Else
      RegCloseKey keyHandle
      Err.Raise 1, MyName, "Sorry! Win98 doesn't support this (i guess), and since i got one, you have to write this code by yourself!"
    End Select
    RegCloseKey keyHandle
  End If
End Property

Property Let Value(ByVal Root As RegRoots, RegPath As String, ValueName As String, ByVal SaveAs As RegDataTypes, V As Variant)
  '       SaveAs!
  
  Dim keyHandle As Long, ret As Long, WhatWeDid As WhatCreateExDid
  Dim strBuf As String, strTypeName As String
  
  If SaveAs = REG_NONE Then SaveAs = REG_SZ
  
  If SaveAs = REG_BINARY Then
    strTypeName = "REG_BINARY"
  ElseIf SaveAs = REG_DWORD Then
    strTypeName = "REG_DWORD"
  ElseIf SaveAs = REG_EXPAND_SZ Then
    strTypeName = "REG_EXPAND_SZ"
  ElseIf SaveAs = REG_MULTI_SZ Then
    strTypeName = "REG_MULTI_SZ"
  ElseIf SaveAs = REG_SZ Then
    strTypeName = "REG_SZ"
  End If
  
  ' , .  , .
  ret = RegCreateKeyEx(Root, RegPath, 0&, strTypeName, 0&, KEY_ALL_ACCESS, ByVal 0&, keyHandle, WhatWeDid)
  HandleError ret, keyHandle
  
  Select Case SaveAs
  Case REG_DWORD
    ' ,   unsigned int
    '   0  4294967296
    If CDbl(V) > 4294967296# Or CDbl(V) < 0 Then Err.Raise 2, MyName, "The value must be from 0 to 4294967296"
    If CDbl(V) > 2147483647 Then
      ret = RegSetValueEx(keyHandle, ValueName, 0&, SaveAs, CLng(CDbl(V) - 4294967296#), 4)
    Else
      ret = RegSetValueEx(keyHandle, ValueName, 0&, SaveAs, CLng(V), 4)
    End If
    HandleError ret, keyHandle
  Case REG_SZ, REG_BINARY, REG_EXPAND_SZ, REG_MULTI_SZ
    ret = RegSetValueEx(keyHandle, ValueName, 0&, SaveAs, ByVal CStr(V), Len(CStr(V)) + 1)
    HandleError ret, keyHandle
  Case Else
    RegCloseKey keyHandle
    Err.Raise 1, MyName, "Sorry! Win98 doesn't support this (i guess), and since i got one, you have to write this code by yourself!"
  End Select
  
  RegCloseKey keyHandle
End Property

Public Function IsThere(ByVal Root As RegRoots, RegPath As String, Optional ValueName) As Boolean
  '   ,   
  '  ,    
  
  Dim ret As Long, keyHandle As Long
  
  ret = RegOpenKeyEx(Root, RegPath, 0&, KEY_ALL_ACCESS, keyHandle)
  HandleError ret, keyHandle
  If keyHandle = 0 Then Exit Function  '  
  
  '  ,   
  If IsMissing(ValueName) Then
    IsThere = True: RegCloseKey keyHandle: Exit Function
  Else
    ret = RegQueryValueEx(keyHandle, CStr(ValueName), 0&, ByVal 0&, ByVal 0&, ByVal 0&)
    HandleError ret, keyHandle
    If ret = 2 Then IsThere = False Else IsThere = True
    RegCloseKey keyHandle
  End If
End Function

Public Function DeleteKey(ByVal Root As RegRoots, RegPath As String) As Boolean
  '  ,   Win98      ,
  '  NT -   ,   .  ,  
  '   .
  '        
  ',       .
  
  Dim ret As Long, keyHandle As Long
  
  ret = RegOpenKeyEx(Root, RegPath, 0&, KEY_ALL_ACCESS, keyHandle)
  HandleError ret, keyHandle
  If keyHandle = 0 Then DeleteKey = True: Exit Function '   
  
  ret = RegDeleteKey(keyHandle, "")
  HandleError ret, keyHandle
  RegCloseKey keyHandle
  DeleteKey = True
End Function

Public Function DeleteValue(ByVal Root As RegRoots, RegPath As String, ValueName As String) As Boolean
  Dim ret As Long, keyHandle As Long
  
  If Len(ValueName) = 0 Then Exit Function
  
  ret = RegOpenKeyEx(Root, RegPath, 0&, KEY_ALL_ACCESS, keyHandle)
  HandleError ret, keyHandle
  If keyHandle = 0 Then DeleteValue = True: Exit Function  '   
  
  ret = RegDeleteValue(keyHandle, ValueName)
  HandleError ret, keyHandle
  RegCloseKey keyHandle
  DeleteValue = True
End Function

Public Function SubKeys(ByVal Root As RegRoots, RegPath As String) As Variant
  ' ,     .
  
  Dim outArr() As String
  Dim ret As Long, keyHandle As Long, keyNum As Long
  Dim keyName As String, keyNameLenght As Long
  
  ret = RegOpenKeyEx(Root, RegPath, 0&, KEY_ALL_ACCESS, keyHandle)
  HandleError ret, keyHandle
  If keyHandle = 0 Then Exit Function '  ,  ,  
  
  ReDim outArr(0 To 0)
  Do
    keyNameLenght = 255
    keyName = Space$(keyNameLenght)
    ret = RegEnumKeyEx(keyHandle, keyNum, keyName, keyNameLenght, ByVal 0&, vbNullString, ByVal 0&, ByVal 0&)
    HandleError ret, keyHandle
    If ret = ERROR_NO_MORE_ITEMS Then Exit Do
    outArr(keyNum) = Left$(keyName, keyNameLenght)
    
    keyNum = keyNum + 1
    ReDim Preserve outArr(UBound(outArr) + 1)
  Loop
  RegCloseKey keyHandle
  ReDim Preserve outArr(UBound(outArr) - 1)
  SubKeys = outArr
End Function

Public Function SubValues(ByVal Root As RegRoots, RegPath As String) As Variant
  ' 
  '  (0, i) -  i- 
  '  (1, i) -  i- 
  '  (2, i) -  i- 
  
  Dim outArr() As Variant
  Dim ret As Long, keyHandle As Long, keyNum As Long
  Dim keyName As String, keyNameLenght As Long
  Dim keyType As Long
  Dim keyData As String, keyDataLenght As Long
  Dim tmpLong As Long
  
  ret = RegOpenKeyEx(Root, RegPath, 0&, KEY_ALL_ACCESS, keyHandle)
  HandleError ret, keyHandle
  If keyHandle = 0 Then Exit Function '  ,  ,  
  
  ReDim outArr(0 To 2, 0 To 0)
  Do
    keyNameLenght = 255
    keyName = Space$(keyNameLenght)
    
    '  ,    
    ret = RegEnumValue(keyHandle, keyNum, keyName, keyNameLenght, 0&, keyType, ByVal 0&, keyDataLenght)
    HandleError ret, keyHandle
    If ret = ERROR_NO_MORE_ITEMS Then Exit Do
    
    outArr(0, keyNum) = Left$(keyName, keyNameLenght)
    outArr(1, keyNum) = keyType
    
    '   
    keyNameLenght = keyNameLenght + 1
    If keyType = REG_DWORD Then
      ret = RegEnumValue(keyHandle, keyNum, keyName, keyNameLenght, 0&, ByVal 0&, tmpLong, 4)
      HandleError ret, keyHandle
      outArr(2, keyNum) = IIf(tmpLong < 0, tmpLong + 4294967296#, tmpLong)
    Else
      keyData = Space$(keyDataLenght)
      ret = RegEnumValue(keyHandle, keyNum, keyName, keyNameLenght, 0&, ByVal 0&, ByVal keyData, keyDataLenght)
      HandleError ret, keyHandle
      outArr(2, keyNum) = Left$(keyData, keyDataLenght - 1)
    End If
    
    keyNum = keyNum + 1
    ReDim Preserve outArr(0 To 2, 0 To keyNum)
  Loop
  RegCloseKey keyHandle
  ReDim Preserve outArr(0 To 2, 0 To UBound(outArr, 2) - 1)
  SubValues = outArr
End Function

Public Function ValueType(ByVal Root As RegRoots, RegPath As String, ValueName As String) As RegDataTypes
  '  
  
  Dim ret As Long, keyHandle As Long, keyType As Long
  
  ret = RegOpenKeyEx(Root, RegPath, 0&, KEY_ALL_ACCESS, keyHandle)
  HandleError ret, keyHandle
  If keyHandle = 0 Then Exit Function '  REG_NONE
  ret = RegQueryValueEx(keyHandle, ValueName, 0&, keyType, ByVal 0&, ByVal 0&)
  HandleError ret, keyHandle
  ValueType = keyType
  RegCloseKey keyHandle
End Function

Public Function SaveToFile(ByVal Root As RegRoots, RegPath As String, SaveTo As String) As Boolean
  '   -  .   ,
  '     ,   .
  '        REG.
  '     INI ,    
  'INI - 64 
  
  Dim ret As Long, keyHandle As Long, fileHandle As Integer, tmpStr As String
  
  If Len(SaveTo) = 0 Then Exit Function
  
  ret = RegOpenKeyEx(Root, RegPath, 0&, KEY_ALL_ACCESS, keyHandle)
  HandleError ret, keyHandle
  If keyHandle = 0 Then Exit Function ' 
  
  fileHandle = FreeFile
  Open SaveTo For Output Access Write As #fileHandle
  Print #fileHandle, "REGEDIT4"
  Print #fileHandle, ""
  
  SaveBranch Root, RegPath, fileHandle
  
  RegCloseKey keyHandle
  Close #fileHandle
  SaveToFile = True
End Function

Private Sub SaveBranch(ByVal Root As RegRoots, RegPath As String, ByVal fileHandle As Integer)
  '    .
  
  '!          .
  '     .
  
  Dim ret As Long, keyHandle As Long
  Dim keyNum As Long, keyType As Long, tmpLong As Long, tmpDbl As Double
  Dim keyName As String, keyNameLenght As Long
  Dim keyData As String, keyDataLenght As Long
  
  ret = RegOpenKeyEx(Root, RegPath, 0&, KEY_ALL_ACCESS, keyHandle)
  HandleError ret, keyHandle
  
  '  
  Print #fileHandle, "[" + RootName(Root) + IIf(Len(RegPath) = 0, "", "\" + RegPath) + "]"
  '   
  ret = RegQueryValueEx(keyHandle, vbNullString, 0&, ByVal 0&, ByVal 0&, keyDataLenght)
  HandleError ret, keyHandle
  keyData = Space$(keyDataLenght)
  ret = RegQueryValueEx(keyHandle, vbNullString, 0&, ByVal 0&, ByVal keyData, keyDataLenght)
  HandleError ret, keyHandle
  Print #fileHandle, "@=""" + Left$(keyData, keyDataLenght - 1) + """"
  
  '   
  Do
    keyNameLenght = 255
    keyName = Space$(keyNameLenght)
    
    ret = RegEnumValue(keyHandle, keyNum, keyName, keyNameLenght, 0&, keyType, ByVal 0&, keyDataLenght)
    HandleError ret, keyHandle
    If ret = ERROR_NO_MORE_ITEMS Then Exit Do
    
    If keyNameLenght > 0 Then
      keyNameLenght = keyNameLenght + 1
      If keyType = REG_DWORD Then
        ret = RegEnumValue(keyHandle, keyNum, keyName, keyNameLenght, 0&, ByVal 0&, tmpLong, 4)
        HandleError ret, keyHandle
        tmpDbl = IIf(tmpLong < 0, tmpLong + 4294967296#, tmpLong)
        Print #fileHandle, """" + Left$(keyName, keyNameLenght) + """=dword:" + Format$(Hex$(tmpDbl), "00000000")
      Else
        keyData = Space$(keyDataLenght)
        ret = RegEnumValue(keyHandle, keyNum, keyName, keyNameLenght, 0&, ByVal 0&, ByVal keyData, keyDataLenght)
        HandleError ret, keyHandle
        keyData = Left$(keyData, keyDataLenght - 1)
        If keyType = REG_SZ Then
          Print #fileHandle, """" + Left$(keyName, keyNameLenght) + """=""" + Replace(keyData, "\", "\\") + """"
        Else
          Print #fileHandle, """" + Left$(keyName, keyNameLenght) + """=hex" + IIf(keyType = 2, "(2)", IIf(keyType = 7, "(7)", "")) + ":" + Hex2String(keyData)
        End If
      End If
    End If
    keyNum = keyNum + 1
  Loop
  ' ,   ...
  Print #fileHandle, ""
  
  '      
  keyNum = 0
  Do
    keyNameLenght = 255
    keyName = Space$(keyNameLenght)
    ret = RegEnumKeyEx(keyHandle, keyNum, keyName, keyNameLenght, ByVal 0&, vbNullString, ByVal 0&, ByVal 0&)
    HandleError ret, keyHandle
    If ret = ERROR_NO_MORE_ITEMS Then Exit Do
    keyName = Left$(keyName, keyNameLenght)
    SaveBranch Root, RegPath + IIf(Len(RegPath) = 0, "", "\") + keyName, fileHandle
    keyNum = keyNum + 1
  Loop
  
  RegCloseKey keyHandle
End Sub

Public Function LoadFromFile(FileName As String) As Boolean
  '     ,      :)
  
  Dim fileHandle As Integer, tmpStr As String
  Dim ValueName As String, ValueValue As Variant
  Dim keyHandle As Long, ret As Long, LT As RegFileLineTypes
  
  fileHandle = FreeFile
  Open FileName For Input As #fileHandle
  
  '     "REGEDIT4"
  Line Input #fileHandle, tmpStr
  If tmpStr <> "REGEDIT4" Then Close #fileHandle: Exit Function
  
  Do Until EOF(fileHandle)  '
    Line Input #fileHandle, tmpStr
    If Len(tmpStr) > 0 Then '  
      LT = LineType(tmpStr, fileHandle, ValueName, ValueValue)
      Select Case LT
      Case lineKey   '   
        If keyHandle <> 0 Then RegCloseKey (keyHandle)
        ret = RegCreateKeyEx(ValueValue, ValueName, 0&, 0&, 0&, KEY_ALL_ACCESS, ByVal 0&, keyHandle, ByVal 0&)
        HandleError ret, keyHandle
      Case lineDefault
        If keyHandle <> 0 Then
          ret = RegSetValueEx(keyHandle, vbNullString, 0&, REG_SZ, ByVal CStr(ValueValue), Len(ValueValue))
          HandleError ret, keyHandle
        End If
      Case lineString, lineExpandedString, lineMultiString, lineHex
        If keyHandle <> 0 Then
          ret = RegSetValueEx(keyHandle, ValueName, 0&, LT, ByVal CStr(ValueValue), Len(ValueValue))
          HandleError ret, keyHandle
        End If
      Case lineDWord
        If keyHandle <> 0 Then
          ret = RegSetValueEx(keyHandle, ValueName, 0&, REG_DWORD, CLng(ValueValue), 4)
          HandleError ret, keyHandle
        End If
      End Select
    End If
  Loop
  
  If keyHandle <> 0 Then RegCloseKey keyHandle
  Close #fileHandle
  LoadFromFile = True
End Function

Private Function LineType(L As String, ByVal fileHandle As Integer, outName As String, outValue) As RegFileLineTypes
  On Local Error GoTo errh
  Dim tmpLng As Long, tmpStr As String
  Dim DefaultMaybe As Boolean
  Dim Equal As Long, Colon As Long
  Dim tmpHex As String, Warp As Boolean
  Dim tmpVal As String
  
  LineType = lineInvalid
  
  If Len(L) = 0 Then Exit Function
  
  L = Trim$(L)
  
  If Left$(L, 1) = "[" And Right$(L, 1) = "]" Then ',   ?
    tmpLng = InStr(L, "\")
    If tmpLng = 0 Then tmpLng = Len(L)  ' "\" .
                                        ', ,   ?
    
    tmpStr = Mid$(L, 2, tmpLng - 2) '    .
                                    '   
    
    If RootValue(tmpStr) <> 0 Then
      ',    -  
      ' :       outName
      '    ,   outValue 
      '  .
      outValue = RootValue(tmpStr)
      If tmpLng < Len(L) Then outName = Mid$(L, tmpLng + 1, Len(L) - tmpLng - 1) Else outName = vbNullString
    Else
      Exit Function
    End If
    
    If Mid$(L, Len(L) - 2, 1) <> "\" Then LineType = lineKey
    Exit Function
  End If
  
  '  ,  ,  L  
  Equal = InStr(L, "=")
  
  If Equal < 4 Then
    If Left$(L, 1) = "@" And Equal = 2 Then DefaultMaybe = True Else Exit Function
  End If
  
  If DefaultMaybe Then
    If Mid$(L, Equal + 1, 1) = """" And Right$(L, 1) = """" Then
      outName = ""
      outValue = Replace(Mid$(L, Equal + 2, Len(L) - Equal - 2), "\\", "\")
      LineType = lineDefault
    End If
    Exit Function
  End If
  
  ',   
  '       ,   
  If Left$(L, 1) <> """" Or Mid$(L, Equal - 1, 1) <> """" Then Exit Function
  outName = Mid$(L, 2, Equal - 3)
  
  ',   ?
  If Mid$(L, Equal + 1, 1) = """" And Right$(L, 1) = """" Then
    outValue = Replace(Mid$(L, Equal + 2, Len(L) - Equal - 2), "\\", "\")
    LineType = lineString
    Exit Function
  End If
  
  ',  .    
  Colon = InStr(Equal + 1, L, ":")
  If Colon = 0 Then Exit Function
  
  '    "=".      
  tmpStr = Mid$(L, Equal + 1, Colon - Equal - 1)
  Select Case tmpStr
  Case "dword"
    '    8 .    .
    tmpStr = Right$(L, 8)
    For tmpLng = 1 To 8
      If InStr("0123456789", Mid$(tmpStr, tmpLng, 1)) = 0 Then Exit Function
    Next
    outValue = Val(tmpStr) 'Val  Double,   .
    '      Unsigned int
    
    If outValue > 4294967296# Or outValue < 0 Then Exit Function
    If outValue > 2147483647 Then outValue = CLng(outValue - 4294967296#)
    LineType = lineDWord
    Exit Function
  Case "hex", "hex(2)", "hex(7)"
    LineType = Switch(tmpStr = "hex", lineHex, tmpStr = "hex(2)", lineExpandedString, tmpStr = "hex(7)", lineMultiString)
    '      , .   ":"
    If Colon = Len(L) Then outValue = vbNullString: Exit Function
    '- - .
    
    '   -     
    '  .     "\",    .
    '  -      fileHandle
    tmpStr = Mid$(L, Colon + 1)
    Do
      Warp = IIf(Right$(tmpStr, 1) = "\", True, False)
      For tmpLng = 1 To IIf(Warp, Len(tmpStr) - 2, Len(tmpStr)) Step 3
        tmpHex = Mid$(tmpStr, tmpLng, 2)
        If InStr("0123456789abcdef", Left$(tmpHex, 1)) = 0 Or InStr("0123456789abcdef", Right$(tmpHex, 1)) = 0 Then LineType = lineInvalid: Exit Function
        tmpVal = tmpVal + Chr$(Val("&h" + tmpHex))
      Next
      If Warp Then
        Line Input #fileHandle, tmpStr
        tmpStr = Trim$(tmpStr)
      End If
    Loop While Warp
    outValue = tmpVal
  Case Else
    Exit Function
  End Select
  
  Exit Function
errh:
  LineType = lineInvalid
End Function

Private Function RootName(ByVal Root As RegRoots) As String
  If Root = HKEY_CLASSES_ROOT Then RootName = "HKEY_CLASSES_ROOT": Exit Function
  If Root = HKEY_CURRENT_CONFIG Then RootName = "HKEY_CURRENT_CONFIG": Exit Function
  If Root = HKEY_CURRENT_USER Then RootName = "HKEY_CURRENT_USER": Exit Function
  If Root = HKEY_DYN_DATA Then RootName = "HKEY_DYN_DATA": Exit Function
  If Root = HKEY_LOCAL_MACHINE Then RootName = "HKEY_LOCAL_MACHINE": Exit Function
  If Root = HKEY_PERFORMANCE_DATA Then RootName = "HKEY_PERFORMANCE_DATA": Exit Function
  If Root = HKEY_USERS Then RootName = "HKEY_USERS": Exit Function
End Function

Private Function RootValue(Root As String) As RegRoots
  If Root = "HKEY_CLASSES_ROOT" Then RootValue = HKEY_CLASSES_ROOT: Exit Function
  If Root = "HKEY_CURRENT_CONFIG" Then RootValue = HKEY_CURRENT_CONFIG: Exit Function
  If Root = "HKEY_CURRENT_USER" Then RootValue = HKEY_CURRENT_USER: Exit Function
  If Root = "HKEY_DYN_DATA" Then RootValue = HKEY_DYN_DATA: Exit Function
  If Root = "HKEY_LOCAL_MACHINE" Then RootValue = HKEY_LOCAL_MACHINE: Exit Function
  If Root = "HKEY_PERFORMANCE_DATA" Then RootValue = HKEY_PERFORMANCE_DATA: Exit Function
  If Root = "HKEY_USERS" Then RootValue = HKEY_USERS: Exit Function
End Function

Private Function Hex2String(hexBuf As String) As String
  Dim i As Long, tmpByte() As Byte
  
  ReDim tmpByte(0 To Len(hexBuf) - 1) As Byte
  tmpByte = StrConv(hexBuf, vbFromUnicode)
  For i = 0 To Len(hexBuf) - 1
    Hex2String = Hex2String + Format$(Hex$(tmpByte(i)), "00") + ","
  Next
  
  '  
  Hex2String = Left$(Hex2String, i * 3 - 1)
End Function

Public Function SetRegHook(ByVal Root As RegRoots, RegPath As String) As Boolean
  Dim ret As Long, keyHandle As Long, evHandle As Long
  Exit Function  '   
  
  '  ,       :(
  '    -   .
  
  
  
  
  'ret = RegOpenKeyEx(Root, RegPath, 0&, KEY_NOTIFY, keyHandle)
  'HandleError ret, keyHandle
  'If ret = 2 Then Exit Function '   
 '
 ' evHandle = CreateEvent(ByVal 0&, False, 0&, "RegEv")
 '
 ' ret = RegNotifyChangeKeyValue(keyHandle, True, REG_NOTIFY_CHANGE_ATTRIBUTES Or REG_NOTIFY_CHANGE_LAST_SET Or REG_NOTIFY_CHANGE_NAME Or REG_NOTIFY_CHANGE_SECURITY, evHandle, True)
 ' HandleError ret, keyHandle
 '
 ' RegCloseKey keyHandle
End Function









